# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@lightly.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



try:
    # Pydantic >=v1.10.17
    from pydantic.v1 import BaseModel, Field, constr, validator
except ImportError:
    # Pydantic v1
    from pydantic import BaseModel, Field, constr, validator
from lightly.openapi_generated.swagger_client.models.sample_write_urls import SampleWriteUrls

class CreateSampleWithWriteUrlsResponse(BaseModel):
    """
    CreateSampleWithWriteUrlsResponse
    """
    id: constr(strict=True) = Field(..., description="MongoDB ObjectId")
    sample_write_urls: SampleWriteUrls = Field(..., alias="sampleWriteUrls")
    __properties = ["id", "sampleWriteUrls"]

    @validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-f0-9]{24}$", value):
            raise ValueError(r"must validate the regular expression /^[a-f0-9]{24}$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True
        use_enum_values = True
        extra = "forbid"

    def to_str(self, by_alias: bool = False) -> str:
        """Returns the string representation of the model"""
        return pprint.pformat(self.dict(by_alias=by_alias))

    def to_json(self, by_alias: bool = False) -> str:
        """Returns the JSON representation of the model"""
        return json.dumps(self.to_dict(by_alias=by_alias))

    @classmethod
    def from_json(cls, json_str: str) -> CreateSampleWithWriteUrlsResponse:
        """Create an instance of CreateSampleWithWriteUrlsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, by_alias: bool = False):
        """Returns the dictionary representation of the model"""
        _dict = self.dict(by_alias=by_alias,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of sample_write_urls
        if self.sample_write_urls:
            _dict['sampleWriteUrls' if by_alias else 'sample_write_urls'] = self.sample_write_urls.to_dict(by_alias=by_alias)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateSampleWithWriteUrlsResponse:
        """Create an instance of CreateSampleWithWriteUrlsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateSampleWithWriteUrlsResponse.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in CreateSampleWithWriteUrlsResponse) in the input: " + str(obj))

        _obj = CreateSampleWithWriteUrlsResponse.parse_obj({
            "id": obj.get("id"),
            "sample_write_urls": SampleWriteUrls.from_dict(obj.get("sampleWriteUrls")) if obj.get("sampleWriteUrls") is not None else None
        })
        return _obj

