# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@lightly.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
try:
    # Pydantic >=v1.10.17
    from pydantic.v1 import BaseModel, Field, StrictStr
except ImportError:
    # Pydantic v1
    from pydantic import BaseModel, Field, StrictStr
from lightly.openapi_generated.swagger_client.models.dataset_sizes import DatasetSizes

class DatasetInformation(BaseModel):
    """
    DatasetInformation
    """
    dataset_sizes: DatasetSizes = Field(..., alias="datasetSizes")
    video_level_sizes: Optional[DatasetSizes] = Field(None, alias="videoLevelSizes")
    dataset_id: StrictStr = Field(..., alias="datasetId")
    dataset_url: StrictStr = Field(..., alias="datasetUrl")
    dataset_name: StrictStr = Field(..., alias="datasetName")
    __properties = ["datasetSizes", "videoLevelSizes", "datasetId", "datasetUrl", "datasetName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True
        use_enum_values = True
        extra = "forbid"

    def to_str(self, by_alias: bool = False) -> str:
        """Returns the string representation of the model"""
        return pprint.pformat(self.dict(by_alias=by_alias))

    def to_json(self, by_alias: bool = False) -> str:
        """Returns the JSON representation of the model"""
        return json.dumps(self.to_dict(by_alias=by_alias))

    @classmethod
    def from_json(cls, json_str: str) -> DatasetInformation:
        """Create an instance of DatasetInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, by_alias: bool = False):
        """Returns the dictionary representation of the model"""
        _dict = self.dict(by_alias=by_alias,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of dataset_sizes
        if self.dataset_sizes:
            _dict['datasetSizes' if by_alias else 'dataset_sizes'] = self.dataset_sizes.to_dict(by_alias=by_alias)
        # override the default output from pydantic by calling `to_dict()` of video_level_sizes
        if self.video_level_sizes:
            _dict['videoLevelSizes' if by_alias else 'video_level_sizes'] = self.video_level_sizes.to_dict(by_alias=by_alias)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DatasetInformation:
        """Create an instance of DatasetInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DatasetInformation.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in DatasetInformation) in the input: " + str(obj))

        _obj = DatasetInformation.parse_obj({
            "dataset_sizes": DatasetSizes.from_dict(obj.get("datasetSizes")) if obj.get("datasetSizes") is not None else None,
            "video_level_sizes": DatasetSizes.from_dict(obj.get("videoLevelSizes")) if obj.get("videoLevelSizes") is not None else None,
            "dataset_id": obj.get("datasetId"),
            "dataset_url": obj.get("datasetUrl"),
            "dataset_name": obj.get("datasetName")
        })
        return _obj

