# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@lightly.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



try:
    # Pydantic >=v1.10.17
    from pydantic.v1 import BaseModel, Field
except ImportError:
    # Pydantic v1
    from pydantic import BaseModel, Field
from lightly.openapi_generated.swagger_client.models.embedding_data2_d import EmbeddingData2D

class ScatterPlotData(BaseModel):
    """
    ScatterPlotData
    """
    pca_embedding_data: EmbeddingData2D = Field(..., alias="pcaEmbeddingData")
    umap_embedding_data: EmbeddingData2D = Field(..., alias="umapEmbeddingData")
    __properties = ["pcaEmbeddingData", "umapEmbeddingData"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True
        use_enum_values = True
        extra = "forbid"

    def to_str(self, by_alias: bool = False) -> str:
        """Returns the string representation of the model"""
        return pprint.pformat(self.dict(by_alias=by_alias))

    def to_json(self, by_alias: bool = False) -> str:
        """Returns the JSON representation of the model"""
        return json.dumps(self.to_dict(by_alias=by_alias))

    @classmethod
    def from_json(cls, json_str: str) -> ScatterPlotData:
        """Create an instance of ScatterPlotData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, by_alias: bool = False):
        """Returns the dictionary representation of the model"""
        _dict = self.dict(by_alias=by_alias,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of pca_embedding_data
        if self.pca_embedding_data:
            _dict['pcaEmbeddingData' if by_alias else 'pca_embedding_data'] = self.pca_embedding_data.to_dict(by_alias=by_alias)
        # override the default output from pydantic by calling `to_dict()` of umap_embedding_data
        if self.umap_embedding_data:
            _dict['umapEmbeddingData' if by_alias else 'umap_embedding_data'] = self.umap_embedding_data.to_dict(by_alias=by_alias)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ScatterPlotData:
        """Create an instance of ScatterPlotData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ScatterPlotData.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in ScatterPlotData) in the input: " + str(obj))

        _obj = ScatterPlotData.parse_obj({
            "pca_embedding_data": EmbeddingData2D.from_dict(obj.get("pcaEmbeddingData")) if obj.get("pcaEmbeddingData") is not None else None,
            "umap_embedding_data": EmbeddingData2D.from_dict(obj.get("umapEmbeddingData")) if obj.get("umapEmbeddingData") is not None else None
        })
        return _obj

